=== debian/changelog ===
augustus-game (4.0.0+dfsg-1) unstable; urgency=medium

  * Initial release. (Closes: #1110478)

 -- Sandro Knauß <hefee@debian.org>  Mon, 11 Aug 2025 21:22:03 +0200
