=== debian/control ===
Source: augustus-game
Section: contrib/games
Priority: optional
Maintainer: Debian Games Team <pkg-games-devel@lists.alioth.debian.org>
Uploaders: Sandro Knauß <hefee@debian.org>
Homepage: https://github.com/keriew/augustus
Vcs-Browser: https://salsa.debian.org/hefee/augustus
Vcs-Git: https://salsa.debian.org/hefee/augustus.git
Standards-Version: 4.7.2
Rules-Requires-Root: no
Build-Depends: debhelper-compat (= 13), cmake
Build-Depends-Arch: libsdl2-dev, libsdl2-mixer-dev, libpng-dev, libexpat-dev
Description: Re-implementation of Caesar III with changes to gameplay
 Augustus is a fully working open-source version of Caesar III, with enhanced,
 customizable gameplay to Caesar III using project Julius UI enhancements.
 Gameplay enhancements include:
 .
  - Roadblocks
  - Market special orders
  - Global labour pool
  - Partial warehouse storage
  - Increased game limits
  - Zoom controls
  - And more!
 .
 Because of gameplay changes and additions, save files from Augustus are NOT
 compatible with Caesar III or Julius. Augustus is able to load Caesar 3 save
 files, but not the other way around. If you want vanilla experience with only
 visual and UI improvements, or want to use save files in base Caesar III,
 check Julius.
 .
 Augustus requires the original assets (graphics, sounds, etc) from Caesar III
 to run. It optionally supports the high-quality MP3 files once provided on the
 Sierra website.

Package: augustus-game
Architecture: any
Depends: augustus-game-data (<< ${source:Version}.1~),
         augustus-game-data  (>= ${source:Version}),
         ${misc:Depends},
         ${shlibs:Depends}
Recommends: python3-tk | zenity | kdialog
Description: Re-implementation of Caesar III with changes to gameplay
 ${source:Extended-Description}

Package: augustus-game-data
Architecture: all
Multi-Arch: foreign
Depends: ${misc:Depends}
Description: shared data for augustus-game
 ${source:Extended-Description}
 .
 This package provides data that is shared between different architectures.
