=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

include /usr/share/dpkg/pkg-info.mk

CONFIGURE_OPTIONS := -DSHORT_NAME=augustus-game
%:
	dh $@

override_dh_auto_configure:
ifeq (-i,$(findstring -i, $(DH_INTERNAL_OPTIONS)))
	@echo " -- Configure for arch all only build --"
	dh_auto_configure -- \
		-DARCH_ALL_ONLY=ON \
		-DSYSTEM_LIBS=OFF \
		$(CONFIGURE_OPTIONS)
else
	dh_auto_configure -- \
		$(CONFIGURE_OPTIONS)
endif

execute_after_dh_auto_install:
	rm debian/tmp/usr/share/augustus-game/assets/LICENSE
