=== debian/watch ===
version=4
opts="dversionmangle=s/\+dfsg\d*$//,repacksuffix=+dfsg,filenamemangle=s%(?:.*?)?v?(\d[\d.]*)\.tar\.gz%augustus-game-$1.tar.gz%" \
    https://github.com/Keriew/augustus/tags \
    (?:.*?/)?v?(\d[\d.]*)\.tar\.gz
